//  

#include<stdio.h>
#include<stdlib.h>
typedef unsigned char BYTE;


class Decoder{
struct item_st{union{int bit;int index;};int p1;int p2;}tree[512];
int tree_count;
int list_count;		//!<   
int tree_root;		//!<  
int file_size;		//!<  
BYTE byte,byte_shift;
FILE *input,*output;	
	void Alarm();			//!<  
	int  GetBit();			//!<    
	int  ReadTree(int);	//!<     
	void Decompress();
public:
	void Work(char*,char*);
};


void Decoder::Alarm()
{
	printf("internal error\n\a");
	exit(-1);
}


int Decoder::GetBit()
{
	BYTE res;
	if(!byte_shift) {
		if(feof(input)) return 0;
		byte=fgetc(input);
		byte_shift=1;		
	}
	res=byte&byte_shift;
	byte_shift<<=1;
	return res;
}


int Decoder::ReadTree(int bit)
{
	int n;
	if(GetBit()) {
		if(tree_count==512) Alarm();
		n=tree_count++;
		tree[n].p1=ReadTree(0);
		tree[n].p2=ReadTree(1);
	} else {
		if(list_count==256) Alarm();
		n=(BYTE)fgetc(input);
		list_count++;
	}
	tree[n].bit=bit;
	return n;
}


void Decoder::Decompress()
{
	int index,n;
	printf("[unpack]\n");
	for(n=0; n<file_size; n++) {
		index=tree_root;
		while(index>=256) {
			if(GetBit()) index=tree[index].p2;
			else index=tree[index].p1;
		}
		fputc(index,output);
	}
}



void Decoder::Work(char *in_name,char *out_name)
{
	byte=0; byte_shift=0; 
	input=fopen(in_name,"rb"); if(!input) {printf("in file not found\n");return;}
	output=fopen(out_name,"wb"); if(!output) {printf("out file io error\n");return;}
	fread(&file_size,1,sizeof(file_size),input);
	tree_count=256; list_count=0;
	printf("[read tree]\n");
	ReadTree(-1);				//    
	if(tree_count==256) tree_root=tree[0].index; else tree_root=256;	//     -   
	Decompress();
	fclose(input);
	fclose(output);
}



void main(int c,char **l)
{
	Decoder decoder;
	if(c!=3) {
		printf("Usage: %s <in_file> <out_file>\n",l[0]);
	} else decoder.Work(l[1],l[2]);
}


